"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Picker = _interopRequireDefault(require("./Picker"));

var _Input = _interopRequireDefault(require("./Input"));

var _Delimeter = _interopRequireDefault(require("./Delimeter"));

var _Control = _interopRequireDefault(require("./Control"));

var _Label = _interopRequireDefault(require("./Label"));

var _paginator = require("./utils/paginator");

var _functional = require("./utils/functional");

var _string = require("./utils/string");

var _core = require("./consts/core");

var _labels = require("./consts/labels");

var _controls = require("./consts/controls");

var _paginator2 = require("./consts/paginator");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Paginator =
/*#__PURE__*/
function (_Component) {
  _inherits(Paginator, _Component);

  function Paginator() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Paginator);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Paginator)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_allPickersCache", {});

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "_visiblePickersCache", {});

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "state", {
      currentIndex: _this.initIndex,
      controlInputValue: _this.initIndex,
      direction: {
        up: true,
        down: false
      }
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onPickerChange", function (value) {
      var index = _this.convertValueToIndex(value);

      if (index === _this.currentIndex) {
        _this.toggleDirection();

        return;
      }

      _this.setState({
        currentIndex: index,
        controlInputValue: index
      });

      _this.props.onPickerChange(index);
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "validateInput", function (value) {
      var castToNumber = Number(value);
      return !isNaN(castToNumber) && isFinite(castToNumber) && castToNumber > 0 && castToNumber <= _this.allPickers;
    });

    _defineProperty(_assertThisInitialized(_assertThisInitialized(_this)), "onInputChange", function (value) {
      _this.setState({
        controlInputValue: value
      });

      if (!_this.validateInput(value)) {
        return;
      }

      _this.onPickerChange(Number(value));
    });

    return _this;
  }

  _createClass(Paginator, [{
    key: "isDelimeter",
    value: function isDelimeter(value) {
      return value === this.delimeterValue;
    }
  }, {
    key: "isControl",
    value: function isControl(value) {
      return value === this.controlUp || value === this.controlDown;
    }
  }, {
    key: "isLabel",
    value: function isLabel(value) {
      return value === this.firstLabel || value === this.lastLabel;
    }
  }, {
    key: "toggleDirection",
    value: function toggleDirection() {
      var _this$direction = this.direction,
          up = _this$direction.up,
          down = _this$direction.down;
      var newDirection = {
        up: !up,
        down: !down
      };
      this.setState({
        direction: newDirection
      });
    }
  }, {
    key: "convertValueToIndex",
    value: function convertValueToIndex(value) {
      switch (value) {
        case this.firstLabel:
          return 1;

        case this.lastLabel:
          return this.allPickers;

        case this.controlUp:
          return this.currentIndex + 1;

        case this.controlDown:
          return this.currentIndex - 1;

        default:
          return value;
      }
    }
  }, {
    key: "generateDelimeter",
    value: function generateDelimeter(value) {
      var _this$props = this.props,
          customDelimeterComponent = _this$props.customDelimeterComponent,
          delimeterClassName = _this$props.delimeterClassName;
      var DelimeterComponent = customDelimeterComponent;
      return _react.default.createElement(DelimeterComponent, {
        key: value,
        className: delimeterClassName,
        value: value
      });
    }
  }, {
    key: "generatePicker",
    value: function generatePicker(value, disabled, picked) {
      var _this$props2 = this.props,
          customPickerComponent = _this$props2.customPickerComponent,
          pickerClassName = _this$props2.pickerClassName;
      var PickerComponent = customPickerComponent;
      return _react.default.createElement(PickerComponent, {
        key: "".concat(value).concat(disabled).concat(picked),
        className: pickerClassName,
        value: value,
        disabled: disabled,
        picked: picked,
        onClick: this.onPickerChange
      });
    }
  }, {
    key: "generateControl",
    value: function generateControl(value, disabled) {
      var _this$props3 = this.props,
          customControlComponent = _this$props3.customControlComponent,
          controlClassName = _this$props3.controlClassName;
      var ControlComponent = customControlComponent;
      return _react.default.createElement(ControlComponent, {
        key: "".concat(value).concat(disabled),
        className: controlClassName,
        value: value,
        disabled: disabled,
        onClick: this.onPickerChange
      });
    }
  }, {
    key: "generateLabel",
    value: function generateLabel(value, disabled) {
      var _this$props4 = this.props,
          customLabelComponent = _this$props4.customLabelComponent,
          labelClassName = _this$props4.labelClassName;
      var LabelComponent = customLabelComponent;
      return _react.default.createElement(LabelComponent, {
        key: "".concat(value).concat(disabled),
        className: labelClassName,
        value: value,
        disabled: disabled,
        onClick: this.onPickerChange
      });
    }
  }, {
    key: "generateSequence",
    value: function generateSequence() {
      var _this2 = this;

      return this.sequence.map(function (_ref) {
        var value = _ref.value,
            disabled = _ref.disabled,
            picked = _ref.picked;

        if (_this2.isDelimeter(value)) {
          return _this2.generateDelimeter(value);
        }

        if (_this2.isLabel(value)) {
          return _this2.generateLabel(value, disabled);
        }

        if (_this2.isControl(value)) {
          return _this2.generateControl(value, disabled);
        }

        return _this2.generatePicker(value, disabled, picked);
      });
    }
  }, {
    key: "generateInputControl",
    value: function generateInputControl() {
      var _this$props5 = this.props,
          enableInputControl = _this$props5.enableInputControl,
          customInputComponent = _this$props5.customInputComponent,
          inputControlValidator = _this$props5.inputControlValidator,
          inputClassName = _this$props5.inputClassName;
      var controlInputValue = this.controlInputValue,
          amount = this.amount;

      if (!enableInputControl || !amount) {
        return null;
      }

      var InputComponent = customInputComponent;
      var validator = inputControlValidator || this.validateInput;
      return _react.default.createElement(InputComponent, {
        className: inputClassName,
        validator: validator,
        onChange: this.onInputChange,
        value: controlInputValue
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement("div", {
        className: this.className
      }, this.generateInputControl(), this.generateSequence());
    }
  }, {
    key: "initIndex",
    get: function get() {
      return this.props.initIndex;
    }
  }, {
    key: "className",
    get: function get() {
      return (0, _string.skipEmptyClassNames)([_paginator2.PAGINATOR, this.props.className]);
    }
  }, {
    key: "amount",
    get: function get() {
      return this.props.amount;
    }
  }, {
    key: "amountPickersToShow",
    get: function get() {
      return this.props.amountPickersToShow;
    }
  }, {
    key: "valuePerPage",
    get: function get() {
      return this.props.valuePerPage;
    }
  }, {
    key: "allPikersCacheKey",
    get: function get() {
      return "amount:".concat(this.amount, "_perPage:").concat(this.valuePerPage);
    }
  }, {
    key: "visiblePickersChacheKey",
    get: function get() {
      return "all:".concat(this.allPickers, "_toShow:").concat(this.amountPickersToShow);
    }
  }, {
    key: "allPickers",
    get: function get() {
      var cachedValue = this._allPickersCache[this.allPikersCacheKey];

      if (cachedValue) {
        return cachedValue;
      }

      var allPickers = (0, _paginator.calculateAllAvailablePickers)(this.amount, this.valuePerPage);
      this._allPickersCache[this.allPikersCacheKey] = allPickers;
      return allPickers;
    }
  }, {
    key: "visiblePickers",
    get: function get() {
      var cachedValue = this._visiblePickersCache[this.visiblePickersChacheKey];

      if (cachedValue) {
        return cachedValue;
      }

      var visiblePickers = (0, _paginator.calculateVisiblePickers)(this.allPickers, this.amountPickersToShow);
      this._visiblePickersCache[this.visiblePickersChacheKey] = visiblePickers;
      return visiblePickers;
    }
  }, {
    key: "indexes",
    get: function get() {
      var currentIndex = this.currentIndex,
          allPickers = this.allPickers,
          visiblePickers = this.visiblePickers,
          direction = this.direction;
      var up = direction.up,
          down = direction.down;
      return (0, _paginator.calculateIndexes)({
        currentIndex: currentIndex,
        up: up,
        down: down,
        all: allPickers,
        visibleAmount: visiblePickers
      });
    }
  }, {
    key: "sequence",
    get: function get() {
      var currentIndex = this.currentIndex,
          allPickers = this.allPickers,
          visiblePickers = this.visiblePickers,
          indexes = this.indexes,
          labelsConfig = this.labelsConfig,
          controlsConfig = this.controlsConfig,
          delimeter = this.delimeter;
      return (0, _paginator.producePickerMap)({
        withLast: indexes.length !== visiblePickers,
        labels: labelsConfig,
        delimeter: delimeter,
        controls: controlsConfig,
        currentIndex: currentIndex,
        indexes: indexes,
        lastIndex: allPickers
      });
    }
  }, {
    key: "labelsConfig",
    get: function get() {
      var enableLabels = this.enableLabels,
          firstLabel = this.firstLabel,
          lastLabel = this.lastLabel;
      return enableLabels ? {
        firstLabel: firstLabel,
        lastLabel: lastLabel
      } : {};
    }
  }, {
    key: "controlsConfig",
    get: function get() {
      var enableControls = this.enableControls,
          controlUp = this.controlUp,
          controlDown = this.controlDown;
      return enableControls ? {
        controlUp: controlUp,
        controlDown: controlDown
      } : {};
    }
  }, {
    key: "delimeter",
    get: function get() {
      var enableDelimeter = this.enableDelimeter,
          delimeterValue = this.delimeterValue;
      return enableDelimeter && delimeterValue;
    }
  }, {
    key: "enableDelimeter",
    get: function get() {
      return this.props.enableDelimeter;
    }
  }, {
    key: "delimeterValue",
    get: function get() {
      return this.props.delimeterValue;
    }
  }, {
    key: "firstLabel",
    get: function get() {
      return this.props.firstLabel;
    }
  }, {
    key: "lastLabel",
    get: function get() {
      return this.props.lastLabel;
    }
  }, {
    key: "enableLabels",
    get: function get() {
      return this.props.enableLabels;
    }
  }, {
    key: "controlUp",
    get: function get() {
      return this.props.controlUp;
    }
  }, {
    key: "controlDown",
    get: function get() {
      return this.props.controlDown;
    }
  }, {
    key: "enableControls",
    get: function get() {
      return this.props.enableControls;
    }
  }, {
    key: "direction",
    get: function get() {
      return this.state.direction;
    }
  }, {
    key: "currentIndex",
    get: function get() {
      return this.state.currentIndex;
    }
  }, {
    key: "controlInputValue",
    get: function get() {
      return this.state.controlInputValue;
    }
  }]);

  return Paginator;
}(_react.Component);

exports.default = Paginator;
Paginator.defaultProps = {
  /** assets configuration **/
  valuePerPage: _paginator2.DEFAULT_VALUE_PER_PAGE,
  amountPickersToShow: _paginator2.DEFAULT_AMOUNT_PICKERS_TO_SHOW,
  className: _core.EMPTY,

  /** customization **/
  customPickerComponent: _Picker.default,
  pickerClassName: _core.EMPTY,

  /** delimeter configuration **/
  enableDelimeter: _paginator2.DEFAULT_ENABLE.DELIMETER,
  customDelimeterComponent: _Delimeter.default,
  delimeterValue: _paginator2.DEFAULT_DELIMETER,
  delimeterClassName: _core.EMPTY,

  /** labels configuration **/
  enableLabels: _paginator2.DEFAULT_ENABLE.LABELS,
  customLabelComponent: _Label.default,
  firstLabel: _labels.FIRST,
  lastLabel: _labels.LAST,
  labelClassName: _core.EMPTY,

  /** controls configuration **/
  enableControls: _paginator2.DEFAULT_ENABLE.CONTROLS,
  customControlComponent: _Control.default,
  controlUp: _controls.CONTROL_UP,
  controlDown: _controls.CONTROL_DOWN,
  controlClassName: _core.EMPTY,

  /** input configuration **/
  enableInputControl: _paginator2.DEFAULT_ENABLE.INPUT_CONTROL,
  customInputComponent: _Input.default,
  inputClassName: _core.EMPTY,

  /** base configuration **/
  onPickerChange: _functional.noop,
  initIndex: _paginator2.DEFAULT_INIT_INDEX
};
Paginator.propTypes = {
  /** mandatory prop **/
  amount: _propTypes.default.number.isRequired,

  /** assets configuration **/
  valuePerPage: _propTypes.default.number,
  amountPickersToShow: _propTypes.default.number,
  className: _propTypes.default.string,

  /** customization **/
  customPickerComponent: _propTypes.default.any,
  pickerClassName: _propTypes.default.string,

  /** delimeter configuration **/
  enableDelimeter: _propTypes.default.bool,
  customDelimeterComponent: _propTypes.default.any,
  delimeterValue: _propTypes.default.string,
  delimeterClassName: _propTypes.default.string,

  /** labels configuration **/
  enableLabels: _propTypes.default.bool,
  customLabelComponent: _propTypes.default.any,
  firstLabel: _propTypes.default.string,
  lastLabel: _propTypes.default.string,
  labelClassName: _propTypes.default.string,

  /** controls configuration **/
  enableControls: _propTypes.default.bool,
  customControlComponent: _propTypes.default.any,
  controlUp: _propTypes.default.any,
  controlDown: _propTypes.default.any,
  controlClassName: _propTypes.default.string,

  /** input configuration **/
  enableInputControl: _propTypes.default.bool,
  customInputComponent: _propTypes.default.any,
  inputControlValidator: _propTypes.default.func,
  inputClassName: _propTypes.default.string,

  /** base configuration **/
  onPickerChange: _propTypes.default.func,
  initIndex: _propTypes.default.number
};